<script setup lang="ts">
import type { User } from '@/types/User';
import { nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components';

const form = ref(false)
const refForm = ref<VForm | null>(null)
const loading = ref(false)
const dialog = ref(false)
const dialogDelete = ref(false)
let editedIndex = -1
let lastId = 4

const initilUser: User = {
  id: -1,
  email: '',
  password: '',
  fullname: '',
  gender: 'male',
  roles: ['user']
}

// const editedUser:User = {
//   id: -1,
//   email: '',
//   password: '',
//   fullname: '',
//   gender: 'male',
//   roles: ['user']
// }

const editedUser = ref<User>(JSON.parse(JSON.stringify(initilUser)))

const users = ref<User[]>([])

const headers = [
  {
    title: 'Id',
    value: 'id',
    key: 'id'
  },
  {
    title: 'email',
    value: 'email',
    key: 'email'
  },
  {
    title: 'Fullname',
    value: 'fullname',
    key: 'fullname'
  },
  {
    title: 'Gender',
    value: 'gender',
    key: 'gender'
  },
  {
    title: 'Roles',
    // value: function (item: User) {
    //     return item.roles.join(',')
    // },
    value: (item: any | User) => item.roles.join(','),
    key: 'roles'
  },
  { title: 'Actions', key: 'actions', sortable: false }
]

function onSubmit() {}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    editedUser.value = Object.assign({}, initilUser)
  })
}

function deleteItemConfirm() {
  //delete item from list
  users.value.splice(editedIndex, 1)
  closeDelete()
}

function editItem(item: User) {
  editedIndex = users.value.indexOf(item)
  editedUser.value = Object.assign({}, item)
  dialog.value = true
}

function deleteItem(item: User) {
  editedIndex = users.value.indexOf(item)
  editedUser.value = Object.assign({}, item)
  dialogDelete.value = true
  editedIndex = -1
}

function initialize() {
  users.value = [
    {
      id: 1,
      email: 'admin',
      password: 'Pass@Word123',
      fullname: 'Admin',
      gender: 'male',
      roles: ['admin', 'user']
    },
    {
      id: 2,
      email: 'user1',
      password: 'Pass@Word123',
      fullname: 'user1',
      gender: 'female',
      roles: ['user']
    },
    {
      id: 3,
      email: 'user2',
      password: 'Pass@Word123',
      fullname: 'user2',
      gender: 'male',
      roles: ['user']
    }
  ]
}

async function save() {
  const { valid } = await refForm.value!.validate()

  if (!valid) return 

  if (editedIndex > -1) {
    Object.assign(users.value[editedIndex], editedUser.value)
  } else {
    users.value.push(editedUser.value)
    editedUser.value.id = lastId++
  }
  editedIndex = -1
  close()
}

function close() {
  dialog.value = false
  nextTick(() => {
    editedUser.value = Object.assign({}, initilUser)
    editedIndex = -1
  })
}

onMounted(() => {
  initialize()
})
</script>

<template>
  <div>
    <!-- <v-table>
      <thead>
        <tr>
          <th class="text-left">ID</th>
          <th class="text-left">email</th>
          <th class="text-left">Fullname</th>
          <th class="text-left">Gender</th>
          <th class="text-left">Roles</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="item in users" :key="item.id">
          <td>{{ item.id }}</td>
          <td>{{ item.email }}</td>
          <td>{{ item.fullname }}</td>
          <td>{{ item.gender }}</td>
          <td>{{ item.roles.join(',') }}</td>
        </tr>
      </tbody>
    </v-table> -->
  </div>

  <div>
    <v-data-table :headers="headers" :items="users">
      <template v-slot:top>
        <v-toolbar flat>
          <v-toolbar-title>My CRUD</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <v-row justify="center">
            <v-dialog v-model="dialog" persistent width="1024">
              <template v-slot:activator="{ props }">
                <v-btn color="primary" v-bind="props"> New User </v-btn>
              </template>
              <v-card>
                <v-card-title>
                  <span class="text-h5">User Profile</span>
                </v-card-title>
                <v-card-text>
                  <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                    <v-container>
                      <v-row>
                        <v-col cols="12" sm="12" md="4">
                          <v-text-field
                            v-model="editedUser.email"
                            :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']"
                            class="mb-2"
                            clearable
                            label="Email"
                          ></v-text-field>
                        </v-col>

                        <v-col cols="12" sm="12" md="4">
                          <v-text-field
                            v-model="editedUser.fullname"
                            :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']"
                            class="mb-2"
                            clearable
                            label="Fullname"
                          ></v-text-field>
                        </v-col>

                        <v-col cols="12" sm="12" md="4">
                          <v-text-field
                            v-model="editedUser.password"
                            :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']"
                            clearable
                            label="Password"
                            placeholder="Enter your password"
                          ></v-text-field>
                        </v-col>

                        <v-col cols="12">
                          <v-combobox
                            label="Combobox"
                            :items="['male', 'female', 'others']"
                            v-model="editedUser.gender"
                          ></v-combobox>
                        </v-col>

                        <v-col cols="12">
                          <v-combobox
                            v-model="editedUser.roles"
                            :items="[
                              { title: 'Admin', value: 'admin' },
                              { title: 'User', value: 'user' }
                            ]"
                            label="Select a favorite activity or create a new one"
                            multiple
                            :return-object="false"
                          ></v-combobox>
                        </v-col>
                      </v-row>
                    </v-container>

                    <!-- <v-btn
                      :disabled="!form"
                      :loading="loading"
                      block
                      color="success"
                      size="large"
                      type="submit"
                      variant="elevated"
                    >
                      Sign In
                    </v-btn> -->
                  </v-form>

                  <small>*indicates required field</small>
                </v-card-text>
                <v-card-actions>
                  <v-spacer></v-spacer>
                  <v-btn color="blue-darken-1" variant="text" @click="close()">
                    Close
                  </v-btn>
                  <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
                </v-card-actions>
              </v-card>
            </v-dialog>
          </v-row>
          <!-- <v-dialog v-model="dialog" max-width="500px">
            <template v-slot:activator="{ props }">
              <v-btn color="primary" dark class="mb-2" v-bind="props"> New Item </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">{{ formTitle }}</span>
              </v-card-title>

              <v-card-text>
                <v-container>
                  <v-row>
                    <v-col cols="12" sm="6" md="4">
                      <v-text-field v-model="editedItem.name" label="Dessert name"></v-text-field>
                    </v-col>
                    <v-col cols="12" sm="6" md="4">
                      <v-text-field v-model="editedItem.calories" label="Calories"></v-text-field>
                    </v-col>
                    <v-col cols="12" sm="6" md="4">
                      <v-text-field v-model="editedItem.fat" label="Fat (g)"></v-text-field>
                    </v-col>
                    <v-col cols="12" sm="6" md="4">
                      <v-text-field v-model="editedItem.carbs" label="Carbs (g)"></v-text-field>
                    </v-col>
                    <v-col cols="12" sm="6" md="4">
                      <v-text-field v-model="editedItem.protein" label="Protein (g)"></v-text-field>
                    </v-col>
                  </v-row>
                </v-container>
              </v-card-text>

              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="close"> Cancel </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog> -->

          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5"
                >Are you sure you want to delete this item?</v-card-title
              >
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>

      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil </v-icon>
        <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>
      <template v-slot:no-data>
        <v-btn color="primary" @click="initialize"> Reset </v-btn>
      </template>
    </v-data-table>
  </div>

  <br />
  <br />

  <!-- <div>
    <v-card class="mx-auto px-6 py-8" max-width="344">
      <v-form v-model="form" @submit.prevent="onSubmit">
        <v-text-field
          v-model="editedUser.email"
          :readonly="loading"
          :rules="[(v) => !!v || 'Field is required']"
          class="mb-2"
          clearable
          label="Email"
        ></v-text-field>

        <v-text-field
          v-model="editedUser.password"
          :readonly="loading"
          :rules="[(v) => !!v || 'Field is required']"
          clearable
          label="Password"
          placeholder="Enter your password"
        ></v-text-field>

        <v-text-field
          v-model="editedUser.fullname"
          :readonly="loading"
          :rules="[(v) => !!v || 'Field is required']"
          class="mb-2"
          clearable
          label="Fullname"
        ></v-text-field>

        <v-combobox
          label="Combobox"
          :items="['male', 'female', 'others']"
          v-model="editedUser.gender"
        ></v-combobox>

        <v-combobox
          v-model="editedUser.roles"
          :items="[
            { title: 'Admin', value: 'admin' },
            { title: 'User', value: 'user' }
          ]"
          label="Select a favorite activity or create a new one"
          multiple
          :return-object="false"
        ></v-combobox>

        <br />

        <v-btn
          :disabled="!form"
          :loading="loading"
          block
          color="success"
          size="large"
          type="submit"
          variant="elevated"
        >
          Sign In
        </v-btn>
      </v-form>
      <pre>
      {{ editedUser }}
    </pre
      >
    </v-card>
  </div> -->
</template>
